
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Nasa dataset &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="MIT dataset" href="MIT.html" />
    <link rel="prev" title="Battery Classes" href="Battery%20Classes.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <ul class="current nav bd-sidenav">
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   Nasa dataset
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="MIT.html">
   MIT dataset
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="COIN.html">
   Tarascon's Coin dataset
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#classes-for-storing-the-raw-data">
   Classes for storing the raw data
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#classes-for-cleaning-and-storing-cleaned-data">
   Classes for cleaning and storing cleaned data
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="nasa-dataset">
<h1>Nasa dataset<a class="headerlink" href="#nasa-dataset" title="Permalink to this headline">¶</a></h1>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">Nasa_Classes</span></code> module.</p>
<p>Path for the clean batteries:
“/Datasets/NASA/B. Saha and K Goebel/Separate_pickles”
or simply <code class="docutils literal notranslate"><span class="pre">import</span> <span class="pre">main</span></code> and do <code class="docutils literal notranslate"><span class="pre">main.path_dict['NASA']</span></code></p>
<p>The Nasa Dataset is composed of a total of 30 useful batteries. They have
varying discharge protocols but their charge protocols are always the same
(CC at 1,5A until Voltage reaches 4,2V, then CV until current decreases to
20mA) Their nominal capacity is 2,1 A.h.
Their discharge protocol varies but this isn’t taken in by our model
so no problem.</p>
<p>Check “Notes.xlsx” file in the dataset folder for more information.</p>
<div class="section" id="classes-for-storing-the-raw-data">
<span id="raw-nasa"></span><h2>Classes for storing the raw data<a class="headerlink" href="#classes-for-storing-the-raw-data" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="Nasa_Classes.Dataset_Nasa">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Nasa_Classes.</span></span><span class="sig-name descname"><span class="pre">Dataset_Nasa</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">file_name</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Nasa_Classes.html#Dataset_Nasa"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Nasa_Classes.Dataset_Nasa" title="Permalink to this definition">¶</a></dt>
<dd><p>Nasa Dataset class. This is based on the “Battery Data Set” by B. Saha and
K. Goebel (check note for full reference).</p>
<p>One <code class="docutils literal notranslate"><span class="pre">Dataset_Nasa</span></code> object corresponds to one battery/one ‘.mat’ file.</p>
<p>This class has attribute <a class="reference internal" href="#Nasa_Classes.Dataset_Nasa.cycle" title="Nasa_Classes.Dataset_Nasa.cycle"><code class="xref py py-attr docutils literal notranslate"><span class="pre">cycle</span></code></a> which is a list with every cycle
(<a class="reference internal" href="#Nasa_Classes.Nasa_Cycle" title="Nasa_Classes.Nasa_Cycle"><code class="xref py py-class docutils literal notranslate"><span class="pre">Nasa_Cycle</span></code></a> objects), which in turn have a
<code class="xref py py-attr docutils literal notranslate"><span class="pre">data</span></code> attribute (<a class="reference internal" href="#Nasa_Classes.Nasa_Data" title="Nasa_Classes.Nasa_Data"><code class="xref py py-class docutils literal notranslate"><span class="pre">Nasa_Data</span></code></a> object) with
the measured data.</p>
<p>That way, to reach into measured data:</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">A</span> <span class="o">=</span> <span class="n">Dataset_Nasa</span><span class="p">(</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">measured_current</span> <span class="o">=</span> <span class="n">Dataset_Nasa</span><span class="o">.</span><span class="n">cycle</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_i</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">measured_voltage</span> <span class="o">=</span> <span class="n">Dataset_Nasa</span><span class="o">.</span><span class="n">cycle</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_v</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Full reference: B. Saha and K. Goebel (2007). “Battery Data Set”,
NASA Ames Prognostics Data Repository
&lt;<a class="reference external" href="https://ti.arc.nasa.gov/tech/dash/groups/pcoe/prognostic-data-repository/#battery">https://ti.arc.nasa.gov/tech/dash/groups/pcoe/prognostic-data-repository/#battery</a>&gt;,
NASA Ames Research Center, Moffett Field, CA</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>file_name</strong> (<em>string</em>) – The name of the .mat file, including the extension.</p>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Dataset_Nasa.Name">
<span class="sig-name descname"><span class="pre">Name</span></span><a class="headerlink" href="#Nasa_Classes.Dataset_Nasa.Name" title="Permalink to this definition">¶</a></dt>
<dd><p>The battery ID (example: ‘B0005’).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Dataset_Nasa.cycle">
<span class="sig-name descname"><span class="pre">cycle</span></span><a class="headerlink" href="#Nasa_Classes.Dataset_Nasa.cycle" title="Permalink to this definition">¶</a></dt>
<dd><p>List of the cycles tested.
See <a class="reference internal" href="#Nasa_Classes.Nasa_Cycle" title="Nasa_Classes.Nasa_Cycle"><code class="xref py py-class docutils literal notranslate"><span class="pre">Nasa_Cycle</span></code></a> and
<a class="reference internal" href="#Nasa_Classes.Nasa_Data" title="Nasa_Classes.Nasa_Data"><code class="xref py py-class docutils literal notranslate"><span class="pre">Nasa_Data</span></code></a> classes for more information.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[<a class="reference internal" href="#Nasa_Classes.Nasa_Cycle" title="Nasa_Classes.Nasa_Cycle">Nasa_Cycle</a>]</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Cycle">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Nasa_Classes.</span></span><span class="sig-name descname"><span class="pre">Nasa_Cycle</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">CYCLE</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">CYCLE_NB</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Nasa_Classes.html#Nasa_Cycle"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Nasa_Classes.Nasa_Cycle" title="Permalink to this definition">¶</a></dt>
<dd><p>Nasa Cycle class. This includes all of the cycle’s information.</p>
<p>This class is called upon initialization of the <a class="reference internal" href="#Nasa_Classes.Dataset_Nasa" title="Nasa_Classes.Dataset_Nasa"><code class="xref py py-class docutils literal notranslate"><span class="pre">Dataset_Nasa</span></code></a>
class.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>CYCLE</strong> (<em>dict</em>) – A dictionary containing all of the cycle’s information except its number</p></li>
<li><p><strong>CYCLE_NB</strong> (<em>int</em>) – The cycle’s number.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Cycle.number">
<span class="sig-name descname"><span class="pre">number</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Cycle.number" title="Permalink to this definition">¶</a></dt>
<dd><p>The cycle number.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Cycle.type">
<span class="sig-name descname"><span class="pre">type</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Cycle.type" title="Permalink to this definition">¶</a></dt>
<dd><p>The cycle type.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>{‘charge’, ‘discharge’, ‘impedance’}</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Cycle.amb_T">
<span class="sig-name descname"><span class="pre">amb_T</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Cycle.amb_T" title="Permalink to this definition">¶</a></dt>
<dd><p>The ambient temperature during measurements [ºC].
(The raw data was already an integer, I just kept it this way)</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Cycle.time">
<span class="sig-name descname"><span class="pre">time</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Cycle.time" title="Permalink to this definition">¶</a></dt>
<dd><p>The date and time of the experiment [datetime.datetime]</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>[datetime.datetime]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Cycle.unix_time">
<span class="sig-name descname"><span class="pre">unix_time</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Cycle.unix_time" title="Permalink to this definition">¶</a></dt>
<dd><p>The date and time of the experiment expressed in unix time [s]</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Cycle.data">
<span class="sig-name descname"><span class="pre">data</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Cycle.data" title="Permalink to this definition">¶</a></dt>
<dd><p>Nasa_Data object containing all of the actual data.
See Nasa_Data for more information.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p><a class="reference internal" href="#Nasa_Classes.Nasa_Data" title="Nasa_Classes.Nasa_Data">Nasa_Data</a></p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Nasa_Classes.</span></span><span class="sig-name descname"><span class="pre">Nasa_Data</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Type</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Nasa_Classes.html#Nasa_Data"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Nasa_Classes.Nasa_Data" title="Permalink to this definition">¶</a></dt>
<dd><p>Nasa Data class. Includes all of the actually measured data.</p>
<p>The attributes of this class depend on the cycle type (‘charge’,
‘discharge’ or ‘impedance’). That’s the reason why this is a required input.</p>
<blockquote>
<div><p>This class is called directly upon initialization of the
<a class="reference internal" href="#Nasa_Classes.Nasa_Cycle" title="Nasa_Classes.Nasa_Cycle"><code class="xref py py-class docutils literal notranslate"><span class="pre">Nasa_Cycle</span></code></a> class.</p>
</div></blockquote>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Data</strong> (<em>dict</em>) – Dictionary containing all of the data.</p></li>
<li><p><strong>Type</strong> (<em>{'charge'</em><em>, </em><em>'discharge'</em><em>, </em><em>'impedance'}</em>) – The cycle type.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.sense_i">
<span class="sig-name descname"><span class="pre">sense_i</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.sense_i" title="Permalink to this definition">¶</a></dt>
<dd><p>Current in sens branch [A] (only for impedance cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.battery_i">
<span class="sig-name descname"><span class="pre">battery_i</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.battery_i" title="Permalink to this definition">¶</a></dt>
<dd><p>Current in battery branch [A] (only for impedance cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.ratio_i">
<span class="sig-name descname"><span class="pre">ratio_i</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.ratio_i" title="Permalink to this definition">¶</a></dt>
<dd><p>Ratio of the above currents [] (only for impedance cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.battery_z">
<span class="sig-name descname"><span class="pre">battery_z</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.battery_z" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery Impedance computed from raw data [Ohms]
(only for impedance cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.rectified_z">
<span class="sig-name descname"><span class="pre">rectified_z</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.rectified_z" title="Permalink to this definition">¶</a></dt>
<dd><p>Calibrated and smoothed battery impedance [Ohms]
(only for impedance cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.Re">
<span class="sig-name descname"><span class="pre">Re</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.Re" title="Permalink to this definition">¶</a></dt>
<dd><p>Estimated electrolyte resistance [Ohms] (only for impedance cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float or complex</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.Rct">
<span class="sig-name descname"><span class="pre">Rct</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.Rct" title="Permalink to this definition">¶</a></dt>
<dd><p>Estimated charge transfer resistance [Ohms] (only for impedance cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.time">
<span class="sig-name descname"><span class="pre">time</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.time" title="Permalink to this definition">¶</a></dt>
<dd><p>Time vector for the cycle [s] (for charge and discharge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.meas_v">
<span class="sig-name descname"><span class="pre">meas_v</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.meas_v" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery terminal voltage [V] (for charge and discharge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.meas_i">
<span class="sig-name descname"><span class="pre">meas_i</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.meas_i" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery output current [A] (for charge and discharge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.meas_t">
<span class="sig-name descname"><span class="pre">meas_t</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.meas_t" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery temperature [ºC] (for charge and discharge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.charge_i">
<span class="sig-name descname"><span class="pre">charge_i</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.charge_i" title="Permalink to this definition">¶</a></dt>
<dd><p>Current measured at charger [A] (only for charge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.charge_v">
<span class="sig-name descname"><span class="pre">charge_v</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.charge_v" title="Permalink to this definition">¶</a></dt>
<dd><p>Voltage measured at charger [V] (only for charge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.load_i">
<span class="sig-name descname"><span class="pre">load_i</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.load_i" title="Permalink to this definition">¶</a></dt>
<dd><p>Current measured at load [A] (only for discharge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.load_v">
<span class="sig-name descname"><span class="pre">load_v</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.load_v" title="Permalink to this definition">¶</a></dt>
<dd><p>Voltage measured at load [V] (only for discharge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Nasa_Data.capacity">
<span class="sig-name descname"><span class="pre">capacity</span></span><a class="headerlink" href="#Nasa_Classes.Nasa_Data.capacity" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery capacity for discharge till 2.7V [A.h]
(only for discharge cycles).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="classes-for-cleaning-and-storing-cleaned-data">
<span id="clean-nasa"></span><h2>Classes for cleaning and storing cleaned data<a class="headerlink" href="#classes-for-cleaning-and-storing-cleaned-data" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Nasa_Classes.</span></span><span class="sig-name descname"><span class="pre">Clean_Battery</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Battery</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_cutoff</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.02</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">z_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">3</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Nasa_Classes.html#Clean_Battery"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Nasa_Classes.Clean_Battery" title="Permalink to this definition">¶</a></dt>
<dd><p>Class that holds the cleaned cycle couples and their data for one Battery.</p>
<p>It takes as a base one Dataset_Nasa class (one Battery from the Nasa
Dataset). From it, it extracts the cycle couples associated to the model’s
inputs and outputs (first a discharge cycle, related to the capacity values,
and then the charge cycle that comes immediately after for the inputs).
Then, it cleans each one of the selected cycles excluding the couples that
present abnormalities.</p>
<p>It cleans the charge cycle by taking away the first few points before the
actual cycle begins and the last ones after the current has reached its
cut-off point (&lt; <cite>i_cutoff</cite>).</p>
<dl class="simple">
<dt>Couples are excluded in this process when:</dt><dd><p>The discharge curve’s capacity value is nan, or it’s below the
<cite>threshold</cite> value.
When the charge cycle is too short (&lt; <cite>min_len</cite>).</p>
</dd>
</dl>
<p>The cycle couples that weren’t excluded then pass by an outlier detection
based on the capacity value. Ouliers are detected by sliding windows and
z-score values.</p>
<p>The remaining, “valid” cycle couples are saved in the attribute <cite>couples</cite>.
No resampling is done at this stage, only during dataset creation for model
training/validation.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Battery</strong> (<a class="reference internal" href="#Nasa_Classes.Dataset_Nasa" title="Nasa_Classes.Dataset_Nasa"><em>Dataset_Nasa</em></a>) – The battery we want to create the class for.</p></li>
<li><p><strong>i_cutoff</strong> (<em>float</em><em>, </em><em>default = 2e-2</em>) – The current cut-off value to be used to determine the end of the charge
cycles [A].</p></li>
<li><p><strong>min_len</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The minimum amount of points a charge cycle must have to be considered
as relevant. Equal to one by default. Something similar is done during
the resampling stages in the dataset creation.</p></li>
<li><p><strong>threshold</strong> (<em>float</em><em>, </em><em>default = 0.1</em>) – the minimum capacity value to be considered as relevant [A.h].</p></li>
<li><p><strong>z_lim</strong> (<em>float</em>) – The maximum zscore allowed when searching for outliers.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.Name">
<span class="sig-name descname"><span class="pre">Name</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Battery.Name" title="Permalink to this definition">¶</a></dt>
<dd><p>The battery’s name.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>string</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.capacity_curve">
<span class="sig-name descname"><span class="pre">capacity_curve</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Battery.capacity_curve" title="Permalink to this definition">¶</a></dt>
<dd><p>A 2D array where the first column corresponds to the cycle couple number
and the second to the associated capacity value [[], A.h].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[float, float]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.raw_couples">
<span class="sig-name descname"><span class="pre">raw_couples</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Battery.raw_couples" title="Permalink to this definition">¶</a></dt>
<dd><p>The number of the charge and discharge cycles in each couple, based on
the Dataset_Nasa’s cycle numbers.</p>
<p>Example:
self.couples[k] = (charge cycle number, discharge cycle number)
Battery.cycle[charge cycle number] = Nasa_Cycle object corresponding to
the couple’s charge cycle. Analogous for the discharge cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[tuple(int)]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.couples">
<span class="sig-name descname"><span class="pre">couples</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Battery.couples" title="Permalink to this definition">¶</a></dt>
<dd><p>Exactly like the <code class="docutils literal notranslate"><span class="pre">raw_couples</span></code> attribute, but without the entries that
are judged as abnormal or that have missing datapoints or that are too
short etc..</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[tuple(int)]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.cycle_couple">
<span class="sig-name descname"><span class="pre">cycle_couple</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Battery.cycle_couple" title="Permalink to this definition">¶</a></dt>
<dd><p>The Clean_Cycle objects corresponding to each couple.
self.cycle_couple[k] = (charge Clean_Cycle, discharge Clean_Cycle)</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[tuple(<a class="reference internal" href="#Nasa_Classes.Clean_Cycle" title="Nasa_Classes.Clean_Cycle">Clean_Cycle</a>)]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="id0">
<span class="sig-name descname"><span class="pre">capacity_curve</span></span><a class="headerlink" href="#id0" title="Permalink to this definition">¶</a></dt>
<dd><p>Array with the capacity value for each discharge cycle. The first
column corresponds to the cycle’s number and the second one to the
capacity value [A.h].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.C_rate">
<span class="sig-name descname"><span class="pre">C_rate</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Battery.C_rate" title="Permalink to this definition">¶</a></dt>
<dd><p>The C rate associated to the battery for nondimensionning the
current [A].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.Q_nominal">
<span class="sig-name descname"><span class="pre">Q_nominal</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Battery.Q_nominal" title="Permalink to this definition">¶</a></dt>
<dd><p>The battery’s nominal capacity (for nondimensionning the SOH) [A.h].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.V_nominal">
<span class="sig-name descname"><span class="pre">V_nominal</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Battery.V_nominal" title="Permalink to this definition">¶</a></dt>
<dd><p>The battery’s nominal voltage (for nondimensionning the voltage) [V].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Battery.clean_cycle_method">
<span class="sig-name descname"><span class="pre">clean_cycle_method</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Cycle</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_cutoff</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.02</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Nasa_Classes.html#Clean_Battery.clean_cycle_method"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Nasa_Classes.Clean_Battery.clean_cycle_method" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for cleaning current, voltage and temperature data for a given
cycle.</p>
<p>The cleaning is done by removing outliers and then the first few and
last points of the cycle, when the current is being adjusted.
Impedance cycles are not supported, only charge and discharge.</p>
<p>This function is called upon initialization of a Clean_Battery class
(see Nasa_Classes.py for more information).</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This function uses the convention where the discharge current is
negative and the charge current positive.
If the cycle is deemed as too short or abnormal, then all of the
arrays are returned as None.</p>
</div>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>This discharge cycle cleaning only works for constant current (CC)
discharge cycles. This must be adapted for more complex discharge
curves if they are to be used in the future.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Cycle</strong> (<a class="reference internal" href="#Nasa_Classes.Nasa_Cycle" title="Nasa_Classes.Nasa_Cycle"><em>Nasa_Cycle</em></a>) – The Cycle we want to clean.</p></li>
<li><p><strong>i_cutoff</strong> (<em>float</em><em>, </em><em>default = 2e-2</em>) – The current cut-off value to be used to determine the end of the
charge cycles [A].</p></li>
<li><p><strong>min_len</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The minimum amount of points a charge cycle must have to be
considered as relevant. Equal to one by default. Something similar
is done during the resampling stages in the dataset creation.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>Cycle_t</strong> (<em>ndarray[float]</em>) – The cycle’s time stamps after cleaning [s].</p></li>
<li><p><strong>Cycle_i</strong> (<em>ndarray[float]</em>) – The cycle’s current values after cleaning [A].</p></li>
<li><p><strong>Cycle_v</strong> (<em>ndarray[float]</em>) – The cycle’s voltage values after cleaning [V].</p></li>
<li><p><strong>Cycle_T</strong> (<em>ndarray[float]</em>) – The cycle’s temperature after cleaning [ºC].</p></li>
</ul>
</p>
</dd>
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><p><strong>AssertionError</strong> – If <cite>Cycle.type</cite> == ‘impedance’.
    If <cite>min_len</cite> &lt; 1.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Cycle">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Nasa_Classes.</span></span><span class="sig-name descname"><span class="pre">Clean_Cycle</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Cycle</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Data</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Nasa_Classes.html#Clean_Cycle"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Nasa_Classes.Clean_Cycle" title="Permalink to this definition">¶</a></dt>
<dd><p>Class structured just like a Nasa_Cycle, but only containing the relevant
cleaned data that is relevant for analysis.</p>
<p>In this regard, this class is incompatible with impedance cycles.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Cycle</strong> (<a class="reference internal" href="#Nasa_Classes.Nasa_Cycle" title="Nasa_Classes.Nasa_Cycle"><em>Nasa_Cycle</em></a>) – The Nasa_Cycle object corresponding to this cycle.</p></li>
<li><p><strong>Data</strong> (<em>ndarray</em><em>[</em><em>floats</em><em>]</em>) – The array containing all of the data.
Each column corresponds to a different variable, in the following
order: Time [s], Current [A], Voltage [V] and Temperature [ºC].</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Cycle.type">
<span class="sig-name descname"><span class="pre">type</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Cycle.type" title="Permalink to this definition">¶</a></dt>
<dd><p>The type of cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>{‘charge’, ‘discharge’}</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Cycle.amb_T">
<span class="sig-name descname"><span class="pre">amb_T</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Cycle.amb_T" title="Permalink to this definition">¶</a></dt>
<dd><p>The ambient temperature during measurements [ºC].
(The raw data was already an integer, I just kept it this way)</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Cycle.time">
<span class="sig-name descname"><span class="pre">time</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Cycle.time" title="Permalink to this definition">¶</a></dt>
<dd><p>The date and time of the experiment.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>datetime.datetime</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Cycle.unix_time">
<span class="sig-name descname"><span class="pre">unix_time</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Cycle.unix_time" title="Permalink to this definition">¶</a></dt>
<dd><p>The date and time of the experiment expressed in unix time [s].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Cycle.data">
<span class="sig-name descname"><span class="pre">data</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Cycle.data" title="Permalink to this definition">¶</a></dt>
<dd><p>Clean_Data class containing all of the actual data.
See Clean_Data for more information.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p><a class="reference internal" href="#Nasa_Classes.Clean_Data" title="Nasa_Classes.Clean_Data">Clean_Data</a></p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Data">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Nasa_Classes.</span></span><span class="sig-name descname"><span class="pre">Clean_Data</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Capacity</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Nasa_Classes.html#Clean_Data"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Nasa_Classes.Clean_Data" title="Permalink to this definition">¶</a></dt>
<dd><p>Clean_Data class. Stores the cleaned data of one Clean_Cycle</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Data</strong> (<em>ndarray</em><em>[</em><em>floats</em><em>]</em>) – The array containing all of the data.
Each column corresponds to a different variable, in the following
order: Time [s], Current [A], Voltage [V] and Temperature [ºC].</p></li>
<li><p><strong>Capacity</strong> (<em>float</em><em>, </em><em>optional</em>) – The capacity value.
This is only necessary for discharge cycles, unit should be [A.h].
If the cycle is a charge cycle then it defaults to None.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Data.meas_v">
<span class="sig-name descname"><span class="pre">meas_v</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Data.meas_v" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery terminal voltage [V].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[floats]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Data.meas_i">
<span class="sig-name descname"><span class="pre">meas_i</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Data.meas_i" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery output current [A].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[floats]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Data.meas_t">
<span class="sig-name descname"><span class="pre">meas_t</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Data.meas_t" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery temperature [ºC].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[floats]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Data.time">
<span class="sig-name descname"><span class="pre">time</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Data.time" title="Permalink to this definition">¶</a></dt>
<dd><p>Time vector for the cycle [s].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[floats]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Nasa_Classes.Clean_Data.capacity">
<span class="sig-name descname"><span class="pre">capacity</span></span><a class="headerlink" href="#Nasa_Classes.Clean_Data.capacity" title="Permalink to this definition">¶</a></dt>
<dd><p>For a discharge cycle, the capacity value [A.h], float.
If it’s a charge cycle, then it is None.</p>
</dd></dl>

</dd></dl>

</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="Battery%20Classes.html" title="previous page">Battery Classes</a>
    <a class='right-next' id="next-link" href="MIT.html" title="next page">MIT dataset</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>